VTK: vtkDIYGhostUtilities Class Reference

| VTK 9.3.1

Classes | Public Types | Public Member Functions | Static Public Member Functions | Protected Member Functions | Static Protected Member Functions | List of all members
vtkDIYGhostUtilities Class Reference

Utilities to produce ghost cells between a collection of data sets of same type. More...

`#include <vtkDIYGhostUtilities.h>`

Inheritance diagram for vtkDIYGhostUtilities:
[legend]
Collaboration diagram for vtkDIYGhostUtilities:
[legend]

## Classes
struct | Block
| Block structure to be used for diy communication. More...
struct | DataSetBlockStructure
| Base block structure for data sets. More...
struct | DataSetInformation
struct | DataSetTypeToBlockTypeConverter
| This helper structure owns a typedef to the block type of `DataSetT` used with diy to generate ghosts. More...
struct | GridBlockStructure
| Structure to inherit from for data sets having a structured grid topology. More...
struct | GridInformation
| Structure storing information needed by a block on it's own grid structure. More...
struct | ImageDataBlockStructure
| Block structure storing information being communicated by neighboring blocks for `vtkImageData`. More...
struct | ImageDataInformation
struct | PolyDataBlockStructure
struct | PolyDataInformation
struct | RectilinearGridBlockStructure
| Block structure storing information being communicated by neighboring blocks for `vtkRectilinearGrid`. More...
struct | RectilinearGridInformation
struct | StructuredGridBlockStructure
| Block structure storing information being communicated by neighboring blocks for `vtkStructuredGrid`. More...
struct | StructuredGridInformation
struct | UnstructuredDataBlockStructure
struct | UnstructuredDataInformation
struct | UnstructuredGridBlockStructure
struct | UnstructuredGridInformation

## Public Types
typedef vtkObject | Superclass
using | VectorType = std::array< double, 3 >
| Convenient typedefs. More...
using | QuaternionType = vtkQuaternion< double >
| Convenient typedefs. More...
using | ExtentType = std::array< int, 6 >
| Convenient typedefs. More...
template<class T >
using | BlockMapType = std::map< int, T >
| Convenient typedefs. More...
using | Links = std::set< int >
| Convenient typedefs. More...
using | LinkMap = std::vector< Links >
| Convenient typedefs. More...
using | ImageDataBlock = Block< ImageDataBlockStructure, ImageDataInformation >
| Block typedefs. More...
using | RectilinearGridBlock = Block< RectilinearGridBlockStructure, RectilinearGridInformation >
| Block typedefs. More...
using | StructuredGridBlock = Block< StructuredGridBlockStructure, StructuredGridInformation >
| Block typedefs. More...
using | UnstructuredDataBlock = Block< UnstructuredDataBlockStructure, UnstructuredDataInformation >
| Block typedefs. More...
using | UnstructuredGridBlock = Block< UnstructuredGridBlockStructure, UnstructuredGridInformation >
| Block typedefs. More...
using | PolyDataBlock = Block< PolyDataBlockStructure, PolyDataInformation >
| Block typedefs. More...

## Public Member Functions
virtual vtkTypeBool | IsA (const char *type)
| Return 1 if this class is the same type of (or a subclass of) the named class. More...
vtkDIYGhostUtilities * | NewInstance () const
void | PrintSelf (ostream &os, vtkIndent indent) override
| Methods invoked by print to print information about the object including superclasses. More...
Public Member Functions inherited from vtkObject
| vtkBaseTypeMacro (vtkObject, vtkObjectBase)
virtual void | DebugOn ()
| Turn debugging output on. More...
virtual void | DebugOff ()
| Turn debugging output off. More...
bool | GetDebug ()
| Get the value of the debug flag. More...
void | SetDebug (bool debugFlag)
| Set the value of the debug flag. More...
virtual void | Modified ()
| Update the modification time for this object. More...
virtual vtkMTimeType | GetMTime ()
| Return this object's modified time. More...
void | RemoveObserver (unsigned long tag)
void | RemoveObservers (unsigned long event)
void | RemoveObservers (const char *event)
void | RemoveAllObservers ()
vtkTypeBool | HasObserver (unsigned long event)
vtkTypeBool | HasObserver (const char *event)
vtkTypeBool | InvokeEvent (unsigned long event)
vtkTypeBool | InvokeEvent (const char *event)
std::string | GetObjectDescription () const override
| The object description printed in messages and PrintSelf output. More...
unsigned long | AddObserver (unsigned long event, vtkCommand *, float priority=0.0f)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
unsigned long | AddObserver (const char *event, vtkCommand *, float priority=0.0f)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
vtkCommand * | GetCommand (unsigned long tag)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
void | RemoveObserver (vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
void | RemoveObservers (unsigned long event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
void | RemoveObservers (const char *event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
vtkTypeBool | HasObserver (unsigned long event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
vtkTypeBool | HasObserver (const char *event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, void(T::*callback)(), float priority=0.0f)
| Overloads to AddObserver that allow developers to add class member functions as callbacks for events. More...
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, void(T::*callback)(vtkObject *, unsigned long, void *), float priority=0.0f)
| Overloads to AddObserver that allow developers to add class member functions as callbacks for events. More...
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, bool(T::*callback)(vtkObject *, unsigned long, void *), float priority=0.0f)
| Allow user to set the AbortFlagOn() with the return value of the callback method. More...
vtkTypeBool | InvokeEvent (unsigned long event, void *callData)
| This method invokes an event and return whether the event was aborted or not. More...
vtkTypeBool | InvokeEvent (const char *event, void *callData)
| This method invokes an event and return whether the event was aborted or not. More...
virtual void | SetObjectName (const std::string &objectName)
| Set/get the name of this object for reporting purposes. More...
virtual std::string | GetObjectName () const
| Set/get the name of this object for reporting purposes. More...
Public Member Functions inherited from vtkObjectBase
const char * | GetClassName () const
| Return the class name as a string. More...
virtual vtkIdType | GetNumberOfGenerationsFromBase (const char *name)
| Given the name of a base class of this class type, return the distance of inheritance between this class type and the named class (how many generations of inheritance are there between this class and the named class). More...
virtual void | Delete ()
| Delete a VTK object. More...
virtual void | FastDelete ()
| Delete a reference to this object. More...
void | InitializeObjectBase ()
void | Print (ostream &os)
| Print an object to an ostream. More...
virtual void | Register (vtkObjectBase *o)
| Increase the reference count (mark as used by another object). More...
virtual void | UnRegister (vtkObjectBase *o)
| Decrease the reference count (release by another object). More...
int | GetReferenceCount ()
| Return the current reference count of this object. More...
void | SetReferenceCount (int)
| Sets the reference count. More...
bool | GetIsInMemkind () const
| A local state flag that remembers whether this object lives in the normal or extended memory space. More...
virtual void | PrintHeader (ostream &os, vtkIndent indent)
| Methods invoked by print to print information about the object including superclasses. More...
virtual void | PrintTrailer (ostream &os, vtkIndent indent)
| Methods invoked by print to print information about the object including superclasses. More...
virtual bool | UsesGarbageCollector () const
| Indicate whether the class uses `vtkGarbageCollector` or not. More...

## Static Public Member Functions
static vtkTypeBool | IsTypeOf (const char *type)
static vtkDIYGhostUtilities * | SafeDownCast (vtkObjectBase *o)
template<class DataSetT >
static int | GenerateGhostCells (std::vector< DataSetT * > &inputsDS, std::vector< DataSetT * > &outputsDS, int outputGhostLevels, vtkMultiProcessController *controller)
| Main pipeline generating ghosts. More...
static int | GenerateGhostCellsImageData (std::vector< vtkImageData * > &inputs, std::vector< vtkImageData * > &outputs, int outputGhostLevels, vtkMultiProcessController *controller)
| Method that can be used to avoid the compile-time overhead of the templated method `GenerateGhostCells`. More...
static int | GenerateGhostCellsRectilinearGrid (std::vector< vtkRectilinearGrid * > &inputs, std::vector< vtkRectilinearGrid * > &outputs, int outputGhostLevels, vtkMultiProcessController *controller)
| Method that can be used to avoid the compile-time overhead of the templated method `GenerateGhostCells`. More...
static int | GenerateGhostCellsStructuredGrid (std::vector< vtkStructuredGrid * > &inputs, std::vector< vtkStructuredGrid * > &outputs, int outputGhostLevels, vtkMultiProcessController *controller)
| Method that can be used to avoid the compile-time overhead of the templated method `GenerateGhostCells`. More...
static int | GenerateGhostCellsPolyData (std::vector< vtkPolyData * > &inputs, std::vector< vtkPolyData * > &outputs, int outputGhostLevels, vtkMultiProcessController *controller)
| Method that can be used to avoid the compile-time overhead of the templated method `GenerateGhostCells`. More...
static int | GenerateGhostCellsUnstructuredGrid (std::vector< vtkUnstructuredGrid * > &inputs, std::vector< vtkUnstructuredGrid * > &outputs, int outputGhostLevels, vtkMultiProcessController *controller)
| Method that can be used to avoid the compile-time overhead of the templated method `GenerateGhostCells`. More...
Static Public Member Functions inherited from vtkObject
static vtkObject * | New ()
| Create an object with Debug turned off, modified time initialized to zero, and reference counting on. More...
static void | BreakOnError ()
| This method is called when vtkErrorMacro executes. More...
static void | SetGlobalWarningDisplay (vtkTypeBool val)
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
static void | GlobalWarningDisplayOn ()
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
static void | GlobalWarningDisplayOff ()
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
static vtkTypeBool | GetGlobalWarningDisplay ()
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
Static Public Member Functions inherited from vtkObjectBase
static vtkTypeBool | IsTypeOf (const char *name)
| Return 1 if this class type is the same type of (or a subclass of) the named class. More...
static vtkIdType | GetNumberOfGenerationsFromBaseType (const char *name)
| Given a the name of a base class of this class type, return the distance of inheritance between this class type and the named class (how many generations of inheritance are there between this class and the named class). More...
static vtkObjectBase * | New ()
| Create an object with Debug turned off, modified time initialized to zero, and reference counting on. More...
static void | SetMemkindDirectory (const char *directoryname)
| The name of a directory, ideally mounted -o dax, to memory map an extended memory space within. More...
static bool | GetUsingMemkind ()
| A global state flag that controls whether vtkObjects are constructed in the usual way (the default) or within the extended memory space. More...

## Protected Member Functions
virtual vtkObjectBase * | NewInstanceInternal () const
| vtkDIYGhostUtilities ()
| ~vtkDIYGhostUtilities () override
Protected Member Functions inherited from vtkObject
| vtkObject ()
| ~vtkObject () override
void | RegisterInternal (vtkObjectBase *, vtkTypeBool check) override
void | UnRegisterInternal (vtkObjectBase *, vtkTypeBool check) override
void | InternalGrabFocus (vtkCommand *mouseEvents, vtkCommand *keypressEvents=nullptr)
| These methods allow a command to exclusively grab all events. More...
void | InternalReleaseFocus ()
| These methods allow a command to exclusively grab all events. More...
Protected Member Functions inherited from vtkObjectBase
| vtkObjectBase ()
virtual | ~vtkObjectBase ()
virtual void | ReportReferences (vtkGarbageCollector *)
| vtkObjectBase (const vtkObjectBase &)
void | operator= (const vtkObjectBase &)

## Static Protected Member Functions
static void | ReinitializeSelectedBits (vtkUnsignedCharArray *ghosts, unsigned char mask)
| Reinitializes the bits that match the input bit mask in the input array to zero. More...
template<class DataSetT >
static void | InitializeGhostPointArray (typename DataSetTypeToBlockTypeConverter< DataSetT >::BlockType *block, DataSetT *output)
| This method will set all ghosts points in `output` to zero. More...
template<class DataSetT >
static void | InitializeGhostCellArray (typename DataSetTypeToBlockTypeConverter< DataSetT >::BlockType *block, DataSetT *output)
| This method will set all ghosts cells in `output` to zero. More...
template<class DataSetT >
static void | ExchangeBoundingBoxes (diy::Master &master, const vtkDIYExplicitAssigner &assigner, std::vector< DataSetT * > &inputs)
| This method exchanges the bounding boxes among blocks. More...
template<class BlockT >
static LinkMap | ComputeLinkMapUsingBoundingBoxes (const diy::Master &master)
template<class DataSetT >
static void | CopyInputsAndAllocateGhosts (diy::Master &master, diy::Assigner &assigner, diy::RegularAllReducePartners &partners, std::vector< DataSetT * > &inputs, std::vector< DataSetT * > &outputs, int outputGhostLevels)
| Copy the inputs into the outputs. More...
template<class DataSetT >
static bool | ExchangeGhosts (diy::Master &master, diy::Assigner &assigner, diy::RegularAllReducePartners &partners, std::vector< DataSetT * > &inputs)
| This method exchanges ghosts between connected blocks. More...
template<class DataSetT >
static void | InitializeGhostArrays (diy::Master &master, std::vector< DataSetT * > &outputs, int outputGhostLevels)
| This methods allocate a point and cell ghost array and fills it with 0. More...
template<class DataSetT >
static void | AddGhostArrays (diy::Master &master, std::vector< DataSetT * > &outputs)
| Adds ghost arrays, which are present in blocks of `master`, to `outputs` point and / or cell data. More...
static void | CloneGeometricStructures (std::vector< vtkImageData * > &inputs, std::vector< vtkImageData * > &outputs)
static void | CloneGeometricStructures (std::vector< vtkRectilinearGrid * > &inputs, std::vector< vtkRectilinearGrid * > &outputs)
static void | CloneGeometricStructures (std::vector< vtkStructuredGrid * > &inputs, std::vector< vtkStructuredGrid * > &outputs)
static void | CloneGeometricStructures (std::vector< vtkUnstructuredGrid * > &inputs, std::vector< vtkUnstructuredGrid * > &outputs)
static void | CloneGeometricStructures (std::vector< vtkPolyData * > &inputs, std::vector< vtkPolyData * > &outputs)
static void | InitializeBlocks (diy::Master &master, std::vector< vtkImageData * > &inputs)
| Method to be overloaded for each supported type of input data set. More...
static void | InitializeBlocks (diy::Master &master, std::vector< vtkRectilinearGrid * > &inputs)
| Method to be overloaded for each supported type of input data set. More...
static void | InitializeBlocks (diy::Master &master, std::vector< vtkStructuredGrid * > &inputs)
| Method to be overloaded for each supported type of input data set. More...
static void | InitializeBlocks (diy::Master &master, std::vector< vtkUnstructuredGrid * > &inputs)
| Method to be overloaded for each supported type of input data set. More...
static void | InitializeBlocks (diy::Master &master, std::vector< vtkPolyData * > &inputs)
| Method to be overloaded for each supported type of input data set. More...
static void | ExchangeBlockStructures (diy::Master &master, std::vector< vtkImageData * > &inputs)
| Method to be overloaded for each supported type of input data set. More...
static void | ExchangeBlockStructures (diy::Master &master, std::vector< vtkRectilinearGrid * > &inputs)
| Method to be overloaded for each supported type of input data set. More...
static void | ExchangeBlockStructures (diy::Master &master, std::vector< vtkStructuredGrid * > &inputs)
| Method to be overloaded for each supported type of input data set. More...
static void | ExchangeBlockStructures (diy::Master &master, std::vector< vtkUnstructuredGrid * > &inputs)
| Method to be overloaded for each supported type of input data set. More...
static void | ExchangeBlockStructures (diy::Master &master, std::vector< vtkPolyData * > &inputs)
| Method to be overloaded for each supported type of input data set. More...
static LinkMap | ComputeLinkMap (const diy::Master &master, std::vector< vtkImageData * > &inputs, int outputGhostLevels)
| Method to be overloaded for each supported input data set type, that computes the minimal link map being necessary to exchange ghosts. More...
static LinkMap | ComputeLinkMap (const diy::Master &master, std::vector< vtkRectilinearGrid * > &inputs, int outputGhostLevels)
| Method to be overloaded for each supported input data set type, that computes the minimal link map being necessary to exchange ghosts. More...
static LinkMap | ComputeLinkMap (const diy::Master &master, std::vector< vtkStructuredGrid * > &inputs, int outputGhostLevels)
| Method to be overloaded for each supported input data set type, that computes the minimal link map being necessary to exchange ghosts. More...
static LinkMap | ComputeLinkMap (const diy::Master &master, std::vector< vtkUnstructuredGrid * > &inputs, int outputGhostLevels)
| Method to be overloaded for each supported input data set type, that computes the minimal link map being necessary to exchange ghosts. More...
static LinkMap | ComputeLinkMap (const diy::Master &master, std::vector< vtkPolyData * > &inputs, int outputGhostLevels)
| Method to be overloaded for each supported input data set type, that computes the minimal link map being necessary to exchange ghosts. More...
static void | EnqueueGhosts (const diy::Master::ProxyWithLink &cp, const diy::BlockID &blockId, vtkImageData *input, ImageDataBlock *block)
| This method enqueues ghosts between communicating blocks. More...
static void | EnqueueGhosts (const diy::Master::ProxyWithLink &cp, const diy::BlockID &blockId, vtkRectilinearGrid *input, RectilinearGridBlock *block)
| This method enqueues ghosts between communicating blocks. More...
static void | EnqueueGhosts (const diy::Master::ProxyWithLink &cp, const diy::BlockID &blockId, vtkStructuredGrid *input, StructuredGridBlock *block)
| This method enqueues ghosts between communicating blocks. More...
static void | EnqueueGhosts (const diy::Master::ProxyWithLink &cp, const diy::BlockID &blockId, vtkUnstructuredGrid *input, UnstructuredGridBlock *block)
| This method enqueues ghosts between communicating blocks. More...
static void | EnqueueGhosts (const diy::Master::ProxyWithLink &cp, const diy::BlockID &blockId, vtkPolyData *input, PolyDataBlock *block)
| This method enqueues ghosts between communicating blocks. More...
static void | DequeueGhosts (const diy::Master::ProxyWithLink &cp, int gid, ImageDataBlockStructure &blockStructure)
| This method dequeues ghosts sent between communicating blocks. More...
static void | DequeueGhosts (const diy::Master::ProxyWithLink &cp, int gid, RectilinearGridBlockStructure &blockStructure)
| This method dequeues ghosts sent between communicating blocks. More...
static void | DequeueGhosts (const diy::Master::ProxyWithLink &cp, int gid, StructuredGridBlockStructure &blockStructure)
| This method dequeues ghosts sent between communicating blocks. More...
static void | DequeueGhosts (const diy::Master::ProxyWithLink &cp, int gid, UnstructuredGridBlockStructure &blockStructure)
| This method dequeues ghosts sent between communicating blocks. More...
static void | DequeueGhosts (const diy::Master::ProxyWithLink &cp, int gid, PolyDataBlockStructure &blockStructure)
| This method dequeues ghosts sent between communicating blocks. More...
static void | DeepCopyInputAndAllocateGhosts (ImageDataBlock *block, vtkImageData *input, vtkImageData *outputs)
| Method to be overloaded for each supported input data set type, This method allocates ghosts in the output. More...
static void | DeepCopyInputAndAllocateGhosts (RectilinearGridBlock *block, vtkRectilinearGrid *input, vtkRectilinearGrid *outputs)
| Method to be overloaded for each supported input data set type, This method allocates ghosts in the output. More...
static void | DeepCopyInputAndAllocateGhosts (StructuredGridBlock *block, vtkStructuredGrid *input, vtkStructuredGrid *outputs)
| Method to be overloaded for each supported input data set type, This method allocates ghosts in the output. More...
static void | DeepCopyInputAndAllocateGhosts (UnstructuredGridBlock *block, vtkUnstructuredGrid *input, vtkUnstructuredGrid *outputs)
| Method to be overloaded for each supported input data set type, This method allocates ghosts in the output. More...
static void | DeepCopyInputAndAllocateGhosts (PolyDataBlock *block, vtkPolyData *input, vtkPolyData *outputs)
| Method to be overloaded for each supported input data set type, This method allocates ghosts in the output. More...
static void | FillGhostArrays (const diy::Master &master, std::vector< vtkImageData * > &outputs, int outputGhostLevels)
| This method sets the ghost arrays in the output. More...
static void | FillGhostArrays (const diy::Master &master, std::vector< vtkRectilinearGrid * > &outputs, int outputGhostLevels)
| This method sets the ghost arrays in the output. More...
static void | FillGhostArrays (const diy::Master &master, std::vector< vtkStructuredGrid * > &outputs, int outputGhostLevels)
| This method sets the ghost arrays in the output. More...
static void | FillGhostArrays (const diy::Master &master, std::vector< vtkUnstructuredGrid * > &outputs, int outputGhostLevels)
| This method sets the ghost arrays in the output. More...
static void | FillGhostArrays (const diy::Master &master, std::vector< vtkPolyData * > &outputs, int outputGhostLevels)
| This method sets the ghost arrays in the output. More...
Static Protected Member Functions inherited from vtkObjectBase
static vtkMallocingFunction | GetCurrentMallocFunction ()
static vtkReallocingFunction | GetCurrentReallocFunction ()
static vtkFreeingFunction | GetCurrentFreeFunction ()
static vtkFreeingFunction | GetAlternateFreeFunction ()

## Additional Inherited Members
Protected Attributes inherited from vtkObject
bool | Debug
vtkTimeStamp | MTime
vtkSubjectHelper * | SubjectHelper
std::string | ObjectName
Protected Attributes inherited from vtkObjectBase
std::atomic< int32_t > | ReferenceCount
vtkWeakPointerBase ** | WeakPointers

## Detailed Description

Utilities to produce ghost cells between a collection of data sets of same type.

vtkDIYGhostUtilities is a set of utilities which produce ghost cells between a collection of data sets of same type, using DIY.

Ghosts are computed from scratch, even if parts of the input already own ghosts. In such instance, ghosts are treated as if they didn't exist in the input.

Mixed types in the input `vtkCompositeDataSet` are supported, in the sense that ghost cells are only exchanged between blocks of same type. Similarly, ghosts are exchanged between blocks that connect.

Blocks connect with different criteria depending on their types:

- `vtkImageData`: Blocks connect if they share face / edge / corner, if they share same dimension (1D / 2D / 3D), and if they have same orientation matrix and same spacing.
- `vtkRectilinearGrid`: Blocks connect if the x, y, and z coordinate arrays match at their interfaces.
- `vtkStructuredGrid`: Blocks connect if external faces of the grids are mangled together, regardless of relative inner orientation. In other words, if grid 1 is spanned by (i1, j1, k1) indexing, and grid 2 is spanned by (i2, j2, k2) indexing, if on one face, (j1, k1) connects with (-i2, -j2), those 2 grids are connected and will exchange ghosts. Two grids partially fitting are discarded. In order for 2 grids to fit, one corner from one face of one grid needs to be an existing point in one face of the second grid. Additionally, every points from this corner on both grids need to match until the opposite corner (opposite w.r.t. each dimension) is reached, and this opposite corner of the grid junction needs to be a corner of either grid.
- `vtkUnstructuredGrid`: Blocks connect if the external surface of neighboring grids match. To do so, only points are looked at. If at least one point matches a point in a neighboring grid, then they are connected. If there are no point global ids in the input, the 3D position of the points is used to determine if grids match, up to floating point precision in the coordinates. Note that integer coordinates can be used with this pipeline. If global ids are present in the input point data, then the pipeline will only look at matching global ids, and ignore point positions.
- `vtkPolyData`: Blocks connect if the boundary edges of neighboring poly data match. The filter behaves the same way it does with `vtkUnstructuredGrid`. Point positions are used to match points if point global ids are not present, and point global ids are used instead if they are present.

Points at the interface between 2 partitions are edited depending on the ownership of the point after the ghost points are generated. One can keep track of which process owns a non-ghost copy of the point if an array associating each point with its process id is available in the input.

Note
  Currently, only `vtkImageData`, `vtkRectilinearGrid`, `vtkStructuredGrid`, `vtkUnstructuredGrid` and `vtkPolyData` are implemented. Unless there is determining structural data added to subclasses of those classes, this filter should work well on subclasses of supported types.

Warning
  This warning only applies for `vtkUnstructuredGrid` and `vtkPolyData` inputs. If there are duplicate points in the outer shell of an input partition, then this filter cannot decide on how to connect the cells properly when generating ghosts. The same phenomenon occurs when the outer shell of the partition has 2 points with the same global id. In such circumstances, use the `vtkStaticCleanUnstructuredGrid` or `vtkStaticCleanPolyData` filter first in order to have a clean input.

Definition at line 102 of file vtkDIYGhostUtilities.h.

## Member Typedef Documentation

## ◆ Superclass

typedef vtkObject vtkDIYGhostUtilities::Superclass

Definition at line 105 of file vtkDIYGhostUtilities.h.

## ◆ VectorType

using vtkDIYGhostUtilities::VectorType = std::array<double, 3>

Convenient typedefs.

Definition at line 112 of file vtkDIYGhostUtilities.h.

## ◆ QuaternionType

using vtkDIYGhostUtilities::QuaternionType = vtkQuaternion<double>

Convenient typedefs.

Definition at line 113 of file vtkDIYGhostUtilities.h.

## ◆ ExtentType

using vtkDIYGhostUtilities::ExtentType = std::array<int, 6>

Convenient typedefs.

Definition at line 114 of file vtkDIYGhostUtilities.h.

## ◆ BlockMapType

template<class T >

using vtkDIYGhostUtilities::BlockMapType = std::map<int, T>

Convenient typedefs.

Definition at line 116 of file vtkDIYGhostUtilities.h.

## ◆ Links

using vtkDIYGhostUtilities::Links = std::set<int>

Convenient typedefs.

Definition at line 117 of file vtkDIYGhostUtilities.h.

## ◆ LinkMap

using vtkDIYGhostUtilities::LinkMap = std::vector<Links>

Convenient typedefs.

Definition at line 118 of file vtkDIYGhostUtilities.h.

## ◆ ImageDataBlock

using vtkDIYGhostUtilities::ImageDataBlock = Block<ImageDataBlockStructure, ImageDataInformation>

Block typedefs.

Definition at line 756 of file vtkDIYGhostUtilities.h.

## ◆ RectilinearGridBlock

using vtkDIYGhostUtilities::RectilinearGridBlock = Block<RectilinearGridBlockStructure, RectilinearGridInformation>

Block typedefs.

Definition at line 757 of file vtkDIYGhostUtilities.h.

## ◆ StructuredGridBlock

using vtkDIYGhostUtilities::StructuredGridBlock = Block<StructuredGridBlockStructure, StructuredGridInformation>

Block typedefs.

Definition at line 758 of file vtkDIYGhostUtilities.h.

## ◆ UnstructuredDataBlock

using vtkDIYGhostUtilities::UnstructuredDataBlock = Block<UnstructuredDataBlockStructure, UnstructuredDataInformation>

Block typedefs.

Definition at line 759 of file vtkDIYGhostUtilities.h.

## ◆ UnstructuredGridBlock

using vtkDIYGhostUtilities::UnstructuredGridBlock = Block<UnstructuredGridBlockStructure, UnstructuredGridInformation>

Block typedefs.

Definition at line 760 of file vtkDIYGhostUtilities.h.

## ◆ PolyDataBlock

using vtkDIYGhostUtilities::PolyDataBlock = Block<PolyDataBlockStructure, PolyDataInformation>

Block typedefs.

Definition at line 761 of file vtkDIYGhostUtilities.h.

## Constructor & Destructor Documentation

## ◆ vtkDIYGhostUtilities()

vtkDIYGhostUtilities::vtkDIYGhostUtilities | ( |  | ) |
| protected

## ◆ ~vtkDIYGhostUtilities()

vtkDIYGhostUtilities::~vtkDIYGhostUtilities | ( |  | ) |
| overrideprotected

## Member Function Documentation

## ◆ IsTypeOf()

static vtkTypeBool vtkDIYGhostUtilities::IsTypeOf | ( | const char * | type | ) |
| static

## ◆ IsA()

virtual vtkTypeBool vtkDIYGhostUtilities::IsA | ( | const char * | name | ) |
| virtual

Return 1 if this class is the same type of (or a subclass of) the named class.

Returns 0 otherwise. This method works in combination with vtkTypeMacro found in vtkSetGet.h.

Reimplemented from vtkObjectBase.

## ◆ SafeDownCast()

static vtkDIYGhostUtilities* vtkDIYGhostUtilities::SafeDownCast | ( | vtkObjectBase * | o | ) |
| static

## ◆ NewInstanceInternal()

virtual vtkObjectBase* vtkDIYGhostUtilities::NewInstanceInternal | ( |  | ) | const
| protectedvirtual

## ◆ NewInstance()

vtkDIYGhostUtilities* vtkDIYGhostUtilities::NewInstance | ( |  | ) | const

## ◆ PrintSelf()

void vtkDIYGhostUtilities::PrintSelf | ( | ostream & | os,
|  | vtkIndent | indent
| ) |  |
| overridevirtual

Methods invoked by print to print information about the object including superclasses.

Typically not called by the user (use Print() instead) but used in the hierarchical print process to combine the output of several classes.

Reimplemented from vtkObject.

## ◆ GenerateGhostCells()

template<class DataSetT >

static int vtkDIYGhostUtilities::GenerateGhostCells | ( | std::vector< DataSetT * > & | inputsDS,
|  | std::vector< DataSetT * > & | outputsDS,
|  | int | outputGhostLevels,
|  | vtkMultiProcessController * | controller
| ) |  |
| static

Main pipeline generating ghosts.

It takes as parameters a list of `DataSetT` for the `inputs` and the `outputs`. Please see `vtkGhostCellsGenerator` for a finer description of what this method does, as it is being used as a backend for this filter.

`outputs` need to be already allocated and be of same size as `inputs`.

## ◆ GenerateGhostCellsImageData()

static int vtkDIYGhostUtilities::GenerateGhostCellsImageData | ( | std::vector< vtkImageData * > & | inputs,
|  | std::vector< vtkImageData * > & | outputs,
|  | int | outputGhostLevels,
|  | vtkMultiProcessController * | controller
| ) |  |
| static

Method that can be used to avoid the compile-time overhead of the templated method `GenerateGhostCells`.

All this method does is call `GenerateGhostCells` with the appropriate template parameter.

## ◆ GenerateGhostCellsRectilinearGrid()

static int vtkDIYGhostUtilities::GenerateGhostCellsRectilinearGrid | ( | std::vector< vtkRectilinearGrid * > & | inputs,
|  | std::vector< vtkRectilinearGrid * > & | outputs,
|  | int | outputGhostLevels,
|  | vtkMultiProcessController * | controller
| ) |  |
| static

Method that can be used to avoid the compile-time overhead of the templated method `GenerateGhostCells`.

All this method does is call `GenerateGhostCells` with the appropriate template parameter.

## ◆ GenerateGhostCellsStructuredGrid()

static int vtkDIYGhostUtilities::GenerateGhostCellsStructuredGrid | ( | std::vector< vtkStructuredGrid * > & | inputs,
|  | std::vector< vtkStructuredGrid * > & | outputs,
|  | int | outputGhostLevels,
|  | vtkMultiProcessController * | controller
| ) |  |
| static

Method that can be used to avoid the compile-time overhead of the templated method `GenerateGhostCells`.

All this method does is call `GenerateGhostCells` with the appropriate template parameter.

## ◆ GenerateGhostCellsPolyData()

static int vtkDIYGhostUtilities::GenerateGhostCellsPolyData | ( | std::vector< vtkPolyData * > & | inputs,
|  | std::vector< vtkPolyData * > & | outputs,
|  | int | outputGhostLevels,
|  | vtkMultiProcessController * | controller
| ) |  |
| static

Method that can be used to avoid the compile-time overhead of the templated method `GenerateGhostCells`.

All this method does is call `GenerateGhostCells` with the appropriate template parameter.

## ◆ GenerateGhostCellsUnstructuredGrid()

static int vtkDIYGhostUtilities::GenerateGhostCellsUnstructuredGrid | ( | std::vector< vtkUnstructuredGrid * > & | inputs,
|  | std::vector< vtkUnstructuredGrid * > & | outputs,
|  | int | outputGhostLevels,
|  | vtkMultiProcessController * | controller
| ) |  |
| static

Method that can be used to avoid the compile-time overhead of the templated method `GenerateGhostCells`.

All this method does is call `GenerateGhostCells` with the appropriate template parameter.

## ◆ ReinitializeSelectedBits()

static void vtkDIYGhostUtilities::ReinitializeSelectedBits | ( | vtkUnsignedCharArray * | ghosts,
|  | unsigned char | mask
| ) |  |
| staticprotected

Reinitializes the bits that match the input bit mask in the input array to zero.

## ◆ InitializeGhostPointArray()

template<class DataSetT >

static void vtkDIYGhostUtilities::InitializeGhostPointArray | ( | typename DataSetTypeToBlockTypeConverter< DataSetT >::BlockType * | block,
|  | DataSetT * | output
| ) |  |
| staticprotected

This method will set all ghosts points in `output` to zero.

It will also allocate a new ghost array if none is already present.

## ◆ InitializeGhostCellArray()

template<class DataSetT >

static void vtkDIYGhostUtilities::InitializeGhostCellArray | ( | typename DataSetTypeToBlockTypeConverter< DataSetT >::BlockType * | block,
|  | DataSetT * | output
| ) |  |
| staticprotected

This method will set all ghosts cells in `output` to zero.

It will also allocate a new ghost array if none is already present.

## ◆ CloneGeometricStructures() [1/5]

static void vtkDIYGhostUtilities::CloneGeometricStructures | ( | std::vector< vtkImageData * > & | inputs,
|  | std::vector< vtkImageData * > & | outputs
| ) |  |
| staticprotected

## ◆ CloneGeometricStructures() [2/5]

static void vtkDIYGhostUtilities::CloneGeometricStructures | ( | std::vector< vtkRectilinearGrid * > & | inputs,
|  | std::vector< vtkRectilinearGrid * > & | outputs
| ) |  |
| staticprotected

## ◆ CloneGeometricStructures() [3/5]

static void vtkDIYGhostUtilities::CloneGeometricStructures | ( | std::vector< vtkStructuredGrid * > & | inputs,
|  | std::vector< vtkStructuredGrid * > & | outputs
| ) |  |
| staticprotected

## ◆ CloneGeometricStructures() [4/5]

static void vtkDIYGhostUtilities::CloneGeometricStructures | ( | std::vector< vtkUnstructuredGrid * > & | inputs,
|  | std::vector< vtkUnstructuredGrid * > & | outputs
| ) |  |
| staticprotected

## ◆ CloneGeometricStructures() [5/5]

static void vtkDIYGhostUtilities::CloneGeometricStructures | ( | std::vector< vtkPolyData * > & | inputs,
|  | std::vector< vtkPolyData * > & | outputs
| ) |  |
| staticprotected

## ◆ InitializeBlocks() [1/5]

static void vtkDIYGhostUtilities::InitializeBlocks | ( | diy::Master & | master,
|  | std::vector< vtkImageData * > & | inputs
| ) |  |
| staticprotected

Method to be overloaded for each supported type of input data set.

In this method, given `BlockType` the block type for the data set type, `BlockType::InformationType` is filled with all information needed from the input to create the output.

## ◆ InitializeBlocks() [2/5]

static void vtkDIYGhostUtilities::InitializeBlocks | ( | diy::Master & | master,
|  | std::vector< vtkRectilinearGrid * > & | inputs
| ) |  |
| staticprotected

Method to be overloaded for each supported type of input data set.

In this method, given `BlockType` the block type for the data set type, `BlockType::InformationType` is filled with all information needed from the input to create the output.

## ◆ InitializeBlocks() [3/5]

static void vtkDIYGhostUtilities::InitializeBlocks | ( | diy::Master & | master,
|  | std::vector< vtkStructuredGrid * > & | inputs
| ) |  |
| staticprotected

Method to be overloaded for each supported type of input data set.

In this method, given `BlockType` the block type for the data set type, `BlockType::InformationType` is filled with all information needed from the input to create the output.

## ◆ InitializeBlocks() [4/5]

static void vtkDIYGhostUtilities::InitializeBlocks | ( | diy::Master & | master,
|  | std::vector< vtkUnstructuredGrid * > & | inputs
| ) |  |
| staticprotected

Method to be overloaded for each supported type of input data set.

In this method, given `BlockType` the block type for the data set type, `BlockType::InformationType` is filled with all information needed from the input to create the output.

## ◆ InitializeBlocks() [5/5]

static void vtkDIYGhostUtilities::InitializeBlocks | ( | diy::Master & | master,
|  | std::vector< vtkPolyData * > & | inputs
| ) |  |
| staticprotected

Method to be overloaded for each supported type of input data set.

In this method, given `BlockType` the block type for the data set type, `BlockType::InformationType` is filled with all information needed from the input to create the output.

## ◆ ExchangeBoundingBoxes()

template<class DataSetT >

static void vtkDIYGhostUtilities::ExchangeBoundingBoxes | ( | diy::Master & | master,
|  | const vtkDIYExplicitAssigner & | assigner,
|  | std::vector< DataSetT * > & | inputs
| ) |  |
| staticprotected

This method exchanges the bounding boxes among blocks.

## ◆ ComputeLinkMapUsingBoundingBoxes()

template<class BlockT >

static LinkMap vtkDIYGhostUtilities::ComputeLinkMapUsingBoundingBoxes | ( | const diy::Master & | master | ) |
| staticprotected

## ◆ ExchangeBlockStructures() [1/5]

static void vtkDIYGhostUtilities::ExchangeBlockStructures | ( | diy::Master & | master,
|  | std::vector< vtkImageData * > & | inputs
| ) |  |
| staticprotected

Method to be overloaded for each supported type of input data set.

This method is called in the pipeline right after diy environment has been set up. It exchanges between every information needed for the data set type `DataSetT` in order to be able to set link connections.

## ◆ ExchangeBlockStructures() [2/5]

static void vtkDIYGhostUtilities::ExchangeBlockStructures | ( | diy::Master & | master,
|  | std::vector< vtkRectilinearGrid * > & | inputs
| ) |  |
| staticprotected

Method to be overloaded for each supported type of input data set.

This method is called in the pipeline right after diy environment has been set up. It exchanges between every information needed for the data set type `DataSetT` in order to be able to set link connections.

## ◆ ExchangeBlockStructures() [3/5]

static void vtkDIYGhostUtilities::ExchangeBlockStructures | ( | diy::Master & | master,
|  | std::vector< vtkStructuredGrid * > & | inputs
| ) |  |
| staticprotected

Method to be overloaded for each supported type of input data set.

This method is called in the pipeline right after diy environment has been set up. It exchanges between every information needed for the data set type `DataSetT` in order to be able to set link connections.

## ◆ ExchangeBlockStructures() [4/5]

static void vtkDIYGhostUtilities::ExchangeBlockStructures | ( | diy::Master & | master,
|  | std::vector< vtkUnstructuredGrid * > & | inputs
| ) |  |
| staticprotected

Method to be overloaded for each supported type of input data set.

This method is called in the pipeline right after diy environment has been set up. It exchanges between every information needed for the data set type `DataSetT` in order to be able to set link connections.

## ◆ ExchangeBlockStructures() [5/5]

static void vtkDIYGhostUtilities::ExchangeBlockStructures | ( | diy::Master & | master,
|  | std::vector< vtkPolyData * > & | inputs
| ) |  |
| staticprotected

Method to be overloaded for each supported type of input data set.

This method is called in the pipeline right after diy environment has been set up. It exchanges between every information needed for the data set type `DataSetT` in order to be able to set link connections.

## ◆ ComputeLinkMap() [1/5]

static LinkMap vtkDIYGhostUtilities::ComputeLinkMap | ( | const diy::Master & | master,
|  | std::vector< vtkImageData * > & | inputs,
|  | int | outputGhostLevels
| ) |  |
| staticprotected

Method to be overloaded for each supported input data set type, that computes the minimal link map being necessary to exchange ghosts.

This method is called after `master` has been relinked.

## ◆ ComputeLinkMap() [2/5]

static LinkMap vtkDIYGhostUtilities::ComputeLinkMap | ( | const diy::Master & | master,
|  | std::vector< vtkRectilinearGrid * > & | inputs,
|  | int | outputGhostLevels
| ) |  |
| staticprotected

Method to be overloaded for each supported input data set type, that computes the minimal link map being necessary to exchange ghosts.

This method is called after `master` has been relinked.

## ◆ ComputeLinkMap() [3/5]

static LinkMap vtkDIYGhostUtilities::ComputeLinkMap | ( | const diy::Master & | master,
|  | std::vector< vtkStructuredGrid * > & | inputs,
|  | int | outputGhostLevels
| ) |  |
| staticprotected

Method to be overloaded for each supported input data set type, that computes the minimal link map being necessary to exchange ghosts.

This method is called after `master` has been relinked.

## ◆ ComputeLinkMap() [4/5]

static LinkMap vtkDIYGhostUtilities::ComputeLinkMap | ( | const diy::Master & | master,
|  | std::vector< vtkUnstructuredGrid * > & | inputs,
|  | int | outputGhostLevels
| ) |  |
| staticprotected

Method to be overloaded for each supported input data set type, that computes the minimal link map being necessary to exchange ghosts.

This method is called after `master` has been relinked.

## ◆ ComputeLinkMap() [5/5]

static LinkMap vtkDIYGhostUtilities::ComputeLinkMap | ( | const diy::Master & | master,
|  | std::vector< vtkPolyData * > & | inputs,
|  | int | outputGhostLevels
| ) |  |
| staticprotected

Method to be overloaded for each supported input data set type, that computes the minimal link map being necessary to exchange ghosts.

This method is called after `master` has been relinked.

## ◆ EnqueueGhosts() [1/5]

static void vtkDIYGhostUtilities::EnqueueGhosts | ( | const diy::Master::ProxyWithLink & | cp,
|  | const diy::BlockID & | blockId,
|  | vtkImageData * | input,
|  | ImageDataBlock * | block
| ) |  |
| staticprotected

This method enqueues ghosts between communicating blocks.

One version of this method is implemented per supported input types. It enqueues ghosts to block of id `blockId`.

## ◆ EnqueueGhosts() [2/5]

static void vtkDIYGhostUtilities::EnqueueGhosts | ( | const diy::Master::ProxyWithLink & | cp,
|  | const diy::BlockID & | blockId,
|  | vtkRectilinearGrid * | input,
|  | RectilinearGridBlock * | block
| ) |  |
| staticprotected

This method enqueues ghosts between communicating blocks.

One version of this method is implemented per supported input types. It enqueues ghosts to block of id `blockId`.

## ◆ EnqueueGhosts() [3/5]

static void vtkDIYGhostUtilities::EnqueueGhosts | ( | const diy::Master::ProxyWithLink & | cp,
|  | const diy::BlockID & | blockId,
|  | vtkStructuredGrid * | input,
|  | StructuredGridBlock * | block
| ) |  |
| staticprotected

This method enqueues ghosts between communicating blocks.

One version of this method is implemented per supported input types. It enqueues ghosts to block of id `blockId`.

## ◆ EnqueueGhosts() [4/5]

static void vtkDIYGhostUtilities::EnqueueGhosts | ( | const diy::Master::ProxyWithLink & | cp,
|  | const diy::BlockID & | blockId,
|  | vtkUnstructuredGrid * | input,
|  | UnstructuredGridBlock * | block
| ) |  |
| staticprotected

This method enqueues ghosts between communicating blocks.

One version of this method is implemented per supported input types. It enqueues ghosts to block of id `blockId`.

## ◆ EnqueueGhosts() [5/5]

static void vtkDIYGhostUtilities::EnqueueGhosts | ( | const diy::Master::ProxyWithLink & | cp,
|  | const diy::BlockID & | blockId,
|  | vtkPolyData * | input,
|  | PolyDataBlock * | block
| ) |  |
| staticprotected

This method enqueues ghosts between communicating blocks.

One version of this method is implemented per supported input types. It enqueues ghosts to block of id `blockId`.

## ◆ DequeueGhosts() [1/5]

static void vtkDIYGhostUtilities::DequeueGhosts | ( | const diy::Master::ProxyWithLink & | cp,
|  | int | gid,
|  | ImageDataBlockStructure & | blockStructure
| ) |  |
| staticprotected

This method dequeues ghosts sent between communicating blocks.

One version of this method is implemented per supported input types. It receives data from block of id `gid` and stores is inside `blockStructured`.

## ◆ DequeueGhosts() [2/5]

static void vtkDIYGhostUtilities::DequeueGhosts | ( | const diy::Master::ProxyWithLink & | cp,
|  | int | gid,
|  | RectilinearGridBlockStructure & | blockStructure
| ) |  |
| staticprotected

This method dequeues ghosts sent between communicating blocks.

One version of this method is implemented per supported input types. It receives data from block of id `gid` and stores is inside `blockStructured`.

## ◆ DequeueGhosts() [3/5]

static void vtkDIYGhostUtilities::DequeueGhosts | ( | const diy::Master::ProxyWithLink & | cp,
|  | int | gid,
|  | StructuredGridBlockStructure & | blockStructure
| ) |  |
| staticprotected

This method dequeues ghosts sent between communicating blocks.

One version of this method is implemented per supported input types. It receives data from block of id `gid` and stores is inside `blockStructured`.

## ◆ DequeueGhosts() [4/5]

static void vtkDIYGhostUtilities::DequeueGhosts | ( | const diy::Master::ProxyWithLink & | cp,
|  | int | gid,
|  | UnstructuredGridBlockStructure & | blockStructure
| ) |  |
| staticprotected

This method dequeues ghosts sent between communicating blocks.

One version of this method is implemented per supported input types. It receives data from block of id `gid` and stores is inside `blockStructured`.

## ◆ DequeueGhosts() [5/5]

static void vtkDIYGhostUtilities::DequeueGhosts | ( | const diy::Master::ProxyWithLink & | cp,
|  | int | gid,
|  | PolyDataBlockStructure & | blockStructure
| ) |  |
| staticprotected

This method dequeues ghosts sent between communicating blocks.

One version of this method is implemented per supported input types. It receives data from block of id `gid` and stores is inside `blockStructured`.

## ◆ CopyInputsAndAllocateGhosts()

template<class DataSetT >

static void vtkDIYGhostUtilities::CopyInputsAndAllocateGhosts | ( | diy::Master & | master,
|  | diy::Assigner & | assigner,
|  | diy::RegularAllReducePartners & | partners,
|  | std::vector< DataSetT * > & | inputs,
|  | std::vector< DataSetT * > & | outputs,
|  | int | outputGhostLevels
| ) |  |
| staticprotected

Copy the inputs into the outputs.

Shallow copying is performed if possible. If not, a deep copy is done.

## ◆ DeepCopyInputAndAllocateGhosts() [1/5]

static void vtkDIYGhostUtilities::DeepCopyInputAndAllocateGhosts | ( | ImageDataBlock * | block,
|  | vtkImageData * | input,
|  | vtkImageData * | outputs
| ) |  |
| staticprotected

Method to be overloaded for each supported input data set type, This method allocates ghosts in the output.

At the point of calling this method, ghosts should have already been exchanged (see `ExchangeGhosts`).

## ◆ DeepCopyInputAndAllocateGhosts() [2/5]

static void vtkDIYGhostUtilities::DeepCopyInputAndAllocateGhosts | ( | RectilinearGridBlock * | block,
|  | vtkRectilinearGrid * | input,
|  | vtkRectilinearGrid * | outputs
| ) |  |
| staticprotected

Method to be overloaded for each supported input data set type, This method allocates ghosts in the output.

At the point of calling this method, ghosts should have already been exchanged (see `ExchangeGhosts`).

## ◆ DeepCopyInputAndAllocateGhosts() [3/5]

static void vtkDIYGhostUtilities::DeepCopyInputAndAllocateGhosts | ( | StructuredGridBlock * | block,
|  | vtkStructuredGrid * | input,
|  | vtkStructuredGrid * | outputs
| ) |  |
| staticprotected

Method to be overloaded for each supported input data set type, This method allocates ghosts in the output.

At the point of calling this method, ghosts should have already been exchanged (see `ExchangeGhosts`).

## ◆ DeepCopyInputAndAllocateGhosts() [4/5]

static void vtkDIYGhostUtilities::DeepCopyInputAndAllocateGhosts | ( | UnstructuredGridBlock * | block,
|  | vtkUnstructuredGrid * | input,
|  | vtkUnstructuredGrid * | outputs
| ) |  |
| staticprotected

Method to be overloaded for each supported input data set type, This method allocates ghosts in the output.

At the point of calling this method, ghosts should have already been exchanged (see `ExchangeGhosts`).

## ◆ DeepCopyInputAndAllocateGhosts() [5/5]

static void vtkDIYGhostUtilities::DeepCopyInputAndAllocateGhosts | ( | PolyDataBlock * | block,
|  | vtkPolyData * | input,
|  | vtkPolyData * | outputs
| ) |  |
| staticprotected

Method to be overloaded for each supported input data set type, This method allocates ghosts in the output.

At the point of calling this method, ghosts should have already been exchanged (see `ExchangeGhosts`).

## ◆ ExchangeGhosts()

template<class DataSetT >

static bool vtkDIYGhostUtilities::ExchangeGhosts | ( | diy::Master & | master,
|  | diy::Assigner & | assigner,
|  | diy::RegularAllReducePartners & | partners,
|  | std::vector< DataSetT * > & | inputs
| ) |  |
| staticprotected

This method exchanges ghosts between connected blocks.

## ◆ InitializeGhostArrays()

template<class DataSetT >

static void vtkDIYGhostUtilities::InitializeGhostArrays | ( | diy::Master & | master,
|  | std::vector< DataSetT * > & | outputs,
|  | int | outputGhostLevels
| ) |  |
| staticprotected

This methods allocate a point and cell ghost array and fills it with 0.

## ◆ AddGhostArrays()

template<class DataSetT >

static void vtkDIYGhostUtilities::AddGhostArrays | ( | diy::Master & | master,
|  | std::vector< DataSetT * > & | outputs
| ) |  |
| staticprotected

Adds ghost arrays, which are present in blocks of `master`, to `outputs` point and / or cell data.

## ◆ FillGhostArrays() [1/5]

static void vtkDIYGhostUtilities::FillGhostArrays | ( | const diy::Master & | master,
|  | std::vector< vtkImageData * > & | outputs,
|  | int | outputGhostLevels
| ) |  |
| staticprotected

This method sets the ghost arrays in the output.

Ghosts have to be already allocated.

## ◆ FillGhostArrays() [2/5]

static void vtkDIYGhostUtilities::FillGhostArrays | ( | const diy::Master & | master,
|  | std::vector< vtkRectilinearGrid * > & | outputs,
|  | int | outputGhostLevels
| ) |  |
| staticprotected

This method sets the ghost arrays in the output.

Ghosts have to be already allocated.

## ◆ FillGhostArrays() [3/5]

static void vtkDIYGhostUtilities::FillGhostArrays | ( | const diy::Master & | master,
|  | std::vector< vtkStructuredGrid * > & | outputs,
|  | int | outputGhostLevels
| ) |  |
| staticprotected

This method sets the ghost arrays in the output.

Ghosts have to be already allocated.

## ◆ FillGhostArrays() [4/5]

static void vtkDIYGhostUtilities::FillGhostArrays | ( | const diy::Master & | master,
|  | std::vector< vtkUnstructuredGrid * > & | outputs,
|  | int | outputGhostLevels
| ) |  |
| staticprotected

This method sets the ghost arrays in the output.

Ghosts have to be already allocated.

## ◆ FillGhostArrays() [5/5]

static void vtkDIYGhostUtilities::FillGhostArrays | ( | const diy::Master & | master,
|  | std::vector< vtkPolyData * > & | outputs,
|  | int | outputGhostLevels
| ) |  |
| staticprotected

This method sets the ghost arrays in the output.

Ghosts have to be already allocated.

The documentation for this class was generated from the following file:

- Parallel/DIY/vtkDIYGhostUtilities.h